import random

"""
Goodrich et al
Data Structures in Python
Chapter 5: Array-Based Sequences

Question R-5.1a1

Use standard control structures to print sum of all numbers 
in an n x n data set, if data is stored in list of lists.
"""

def random_list(capacity):
    mylist = [0]*capacity
    for k in range(capacity):
        mylist[k] = random.randrange(0,10)
    return mylist

if __name__=="__main__":
    n = 20
    masterlist = [None]*n
    for k in range(n):
        masterlist[k] = random_list(n)
    
    print( sum([sum(p) for p in masterlist]) )
    