import sys
from matplotlib.pyplot import *
import seaborn as sns

"""
Goodrich et al
Data Structures in Python
Chapter 5: Array-Based Sequences

Question R-3

Modify code fragment to demonstrate that 
the list class reizes its underlying array
when you pop elements from the list

PLOTS OR IT DIDNT HAPPEN
"""

data = []

sequence = [1000,-800,200,-200,1000]
tot = sum(sequence)

so = sys.getsizeof(data)

x = [0]*tot
y = [0]*tot

for n in sequence:
    if(n>0):
        print("++++ADDING ITEMS++++")
    else:
        print("----REMOVING ITEMS----")

    for k in range(abs(n)):
        sonew = sys.getsizeof(data)
        mylen = len(data)

        x.append(sonew)
        y.append(mylen)
    
        if(sonew != so):
            so = sonew
            print("len {0}, sizeof (bytes) {1}".format(sonew,mylen))
    
        if(n>0):
            data.append(None)
        else:
            data.pop()



xlabel('Array size')
ylabel('Byte size')
title('Size in bytes vs. List size')

i = 0
for n,w in zip(sequence,[abs(j) for j in sequence]):
    plot(x[i:i+w],y[i:i+w],'-o',label=str(n))
    i += w

legend()
savefig('listsize-pop.png')
show()




